
/*
 * The interface for the data sent by the model to the view
 * when asking for an update of the view
 *
 * This abstracts away from the details of the representation
 * of mazes, by providing a set of predicates describing which
 * openings are visible
 *
 */


public interface Visible {

    public Direction direction ();

    public boolean left ();
    public boolean right ();
    public boolean front ();
    public boolean frontleft ();
    public boolean frontright ();
    public boolean frontfront ();
    public boolean frontfrontleft ();
    public boolean frontfrontright ();
    public boolean frontfrontfront ();

    public boolean frontwin ();
    public boolean frontfrontwin ();
    
}